/*
 * open-qrcode.js  -- URLQRR[h\ (Google Chart APIoR)
 *
 */

var menu_holder = new Array();

init();

function init()
{
    var idx, menu;

    // add to MainWnd.PopupTextMenu / selected link
    idx = JaneScript.MenuIndex("MainWnd.PopupTextMenu", "TextPopupReleaseProtect");

    menu = JaneScript.InsertMenu("MainWnd.PopupTextMenu",
                                 "",
                                 idx + 1);
    menu.Caption = "ΏۂQRR[h\";
    menu.OnClick = function(menu_obj, target_info) {
        show_qrcode(target_info.PopupObject.FocusedLink);
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        is_enable = (target_info.PopupObject.FocusedLink != "" &&
                     ! target_info.PopupObject.FocusedLink.match(/^#/))
        menu_obj.Enabled = is_enable;
        menu_obj.Visible = is_enable;
    };
    menu_holder.push(menu);

    // add to MainWnd.PopupTextMenu / selection
    idx = JaneScript.MenuIndex("MainWnd.PopupTextMenu", "TextPopUpOpenSelectionURLs");

    menu = JaneScript.InsertMenu("MainWnd.PopupTextMenu",
                                 "",
                                 idx + 1);
    menu.Caption = "I͈͂QRR[h\";
    menu.OnClick = function(menu_obj, target_info) {
        show_qrcode(target_info.PopupObject.Selection);
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        is_enable = (target_info.PopupObject.Selection != "");
        menu_obj.Enabled = is_enable;
        menu_obj.Visible = is_enable;
    };
    menu_holder.push(menu);

    // add to MainWnd.PopupTree
    idx = JaneScript.MenuIndex("MainWnd.PopupTree", "PopupTreeOpenByBrowser");

    menu = JaneScript.InsertMenu("MainWnd.PopupTree",
                                 "",
                                 idx + 1);
    menu.Caption = "QRR[h\";
    menu.OnClick = function(menu_obj, target_info) {
        show_qrcode(target_info.PopupObject.Url);
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        menu_obj.Enabled = (target_info.PopupObject.BoardType == "Board");
    };
    menu_holder.push(menu);

    // add to MainWnd.ThreadPopupMenu
    idx = JaneScript.MenuIndex("MainWnd.ThreadPopupMenu", "ViewPopupOpenByBrowser");

    menu = JaneScript.InsertMenu("MainWnd.ThreadPopupMenu",
                                 "",
                                 idx + 1);
    menu.Caption = "QRR[h\";
    menu.OnClick = function(menu_obj, target_info) {
        show_qrcode(target_info.PopupObject.Thread.URL);
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        menu_obj.Enabled = (target_info.PopupObject.Thread != null);
    };
    menu_holder.push(menu);

    // add to MainWnd.MainMenu / thread list
    idx = JaneScript.MenuIndex("MainWnd.MainMenu", "MenuListOpenByBrowser");

    menu = JaneScript.InsertMenu("MainWnd.MainMenu",
                                 "MenuList",
                                 idx + 1);
    menu.Caption = "QRR[h\";
    menu.OnClick = function(menu_obj, target_info) {
        show_qrcode(JaneScript.CurrentBoard().Url);
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        menu_obj.Enabled = (JaneScript.CurrentBoard() != null &&
                            JaneScript.CurrentBoard().BoardType == "Board");
    };
    menu_holder.push(menu);

    // add to MainWnd.MainMenu / thread
    idx = JaneScript.MenuIndex("MainWnd.MainMenu", "MenuThreOpenByBrowser");

    menu = JaneScript.InsertMenu("MainWnd.MainMenu",
                                 "MenuThre",
                                 idx + 1);
    menu.Caption = "QRR[h\";
    menu.OnClick = function(menu_obj, target_info) {
        show_qrcode(JaneScript.ActiveView().Thread.URL);
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        menu_obj.Enabled = (JaneScript.ActiveView() != null &&
                            JaneScript.ActiveView().Thread != null);
    };
    menu_holder.push(menu);

    // clean-up
    menu = null;
}

function show_qrcode(str)
{
    JaneScript.Open("http://chart.apis.google.com/chart?chs=177x177&cht=qr&choe=Shift_JIS&chl=" + JaneScript.UrlEncode(str, "UTF-8"), 0, 0, true, true, true);
}
